/*
 * ChatSession.java
 *
 * Created on September 25, 2002, 4:30 PM
 */

package examples.instantmessaging;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import examples.instantmessaging.presence.*;
/**
 *
 * @author  deruelle
 * @version 1.0
 */
public class ChatSession  {

    private ChatFrame chatFrame;
    
    private String localTag;
    private String remoteTag;
    private String callId;
    private boolean localInitiateSession;
    private String textSent;
    
    private Vector routes;
    private boolean EXITED_SESSION;
    
    /** Creates new ChatSession */
    public ChatSession() {
        chatFrame=null;
        
        init();
    }

    public void init() {
        localTag=null;
        remoteTag=null;
        callId=null;
        textSent=null;
        EXITED_SESSION=false;
        localInitiateSession=false;
        routes=null;
    }
    
   
    
    public Vector getRoutes() {
        return routes;
    }
    
    public void setRoutes(Vector routes) {
        this.routes=routes;
    }
    
    public boolean equalsCallId(String callIdentifier) {
        if (callId!=null && callId.equals(callIdentifier)) {
            DebugIM.println("DEBUG, ChatSession, equalsCallId(), the callId are identical");
            return true;
        }
        else {
            DebugIM.println("DEBUG, ChatSession, equalsCallId(), the callId are not identical");
             return false;
        }
       
    }
    
    public void setChatFrame(ChatFrame chatFrame) {
        this.chatFrame=chatFrame;
    }
    
    public void setExitedSession(boolean exited,String text) {
        EXITED_SESSION=exited;
        setInfo(text);
    }
    
    public boolean hasExited() {
        return EXITED_SESSION;
    }
    
    public ChatFrame getChatFrame() {
        return chatFrame;
    }
    
    public String getBuddy() {
        return chatFrame.getContact();
    }
    
    public String getRemoteTag() {
        return remoteTag;
    }
    
    public String getLocalTag() {
        return localTag;
    }
    
    public String getCallId() {
        return callId;
    }
    
    public void setRemoteTag(String remoteTag) {
        this.remoteTag=remoteTag;
    }
    
     public void setLocalTag(String localTag) {
        this.localTag=localTag;
    }
    
    public void setCallId(String callId) {
        this.callId=callId;
    }
    
    public boolean isLocalInitiateSession() {
        return localInitiateSession;
    }

    public boolean hasCallId() {
        return callId!=null;
    }
    
    public void setInfo(String text) {
        chatFrame.setInfo(text);
    }
    
    public void setLocalInitiateSession() {
        localInitiateSession=true;
    }
    
    public void setRemoteInitiateSession() {
        localInitiateSession=false;
    }
    
    public void displayRemoteText(String text) {
        chatFrame.displayRemoteText(text);   
    }
    
    public void displayLocalText() {
        chatFrame.displayLocalText(textSent);   
    }
    
    public void removeSentText() {
        chatFrame.removeSentText();   
    }
    
    public String getRemoteSipURL() {
       return chatFrame.getContact();
    }
    
    
    public void sendIMActionPerformed(ActionEvent evt){
        try{
            //if ( EXITED_SESSION ) {
            //    new AlertInstantMessaging(
            //    "Unable to send Messages, close the window!!!",JOptionPane.ERROR_MESSAGE);
            //}
            //else {
                    // Send a MESSAGE to the proxy
                    // and wait for the OK.
                    InstantMessagingGUI imGUI=chatFrame.getInstantMessagingGUI();
                    ListenerInstantMessaging listenerIM=imGUI.getListenerInstantMessaging();
                    IMUserAgent imUserAgent=imGUI.getInstantMessagingUserAgent();
                    IMMessageProcessing imMessageProcessing=imUserAgent.getIMMessageProcessing();
                    
                    String remoteSipURL=getRemoteSipURL();
                    if (remoteSipURL!=null) {
                        String localSipURL=listenerIM.getLocalSipURL();
                        JTextArea messageTextArea=chatFrame.getMessageTextArea();
                        String text= messageTextArea.getText();
                        if (text==null|| text.trim().equals(""))
                            new AlertInstantMessaging(
                            "You must type something!!!",JOptionPane.ERROR_MESSAGE);
                        else{
                            textSent=text;
                            imMessageProcessing.sendMessage(localSipURL,remoteSipURL,text,this);
                        }
                    }
                    else
                        new AlertInstantMessaging(
                        "You must set a remote url!!!",JOptionPane.ERROR_MESSAGE);
               
          //  }
        }
        catch(Exception e) {
            e.printStackTrace();
        }   
    }
    
    public void sendBye() {
        if ( !EXITED_SESSION ) {
            // send a BYE if we didn't receive one!!
            // cleaning the session!!!
            InstantMessagingGUI imGUI=chatFrame.getInstantMessagingGUI();
            ListenerInstantMessaging listenerIM=imGUI.getListenerInstantMessaging();
            IMUserAgent imUserAgent=imGUI.getInstantMessagingUserAgent();
            IMByeProcessing imByeProcessing=imUserAgent.getIMByeProcessing();  
            
            String localSipURL=listenerIM.getLocalSipURL();
            String remoteSipURL=getRemoteSipURL();
            //imByeProcessing.sendBye(localSipURL,remoteSipURL,this);
        }
    }
   
    
}