/*
 * AckProcessing.java
 *
 * Created on July 29, 2002, 11:09 AM
 */

package examples.proxy;

import examples.proxy.*;
import examples.proxy.registrar.*;
import javax.sip.*;
import javax.sip.message.*; 
import javax.sip.header.*;
import javax.sip.address.*;
/** Process ACK messages.
*
*@version  JAIN-SIP-1.1
*
*@author Olivier Deruelle <deruelle@nist.gov>  <br/>
*@author M. Ranganathan <mranga@nist.gov>  <br/>
*
*<a href="{@docRoot}/uncopyright.html">This code is in the public domain.</a>
*
*/
public class AckProcessing  implements MethodProcessing {

    public void processResponse (Proxy proxy,
		Response response, ClientTransaction clientTransaction) {
	if (ProxyDebug.debug)
		ProxyDebug.println("Huh?? Unexpected method in response");
    }
    
    public void processRequest(Proxy proxy,
     Request request,ServerTransaction serverTransaction) {
     try {
          ProxyDebug.println("Processing ACK in progress:");
          TransactionsMapping transactionsMapping=
			proxy.getTransactionsMapping();
	
          ClientTransaction clientTransaction=transactionsMapping.
                   getClientTransaction(serverTransaction);
          if (clientTransaction !=null ) {
	      // The ACK is for a transaction which we have mapped.
	      if (ProxyDebug.debug) ProxyDebug.println (" Forwarding ACK ");
	      proxy.getSipProvider().
			sendRequest(clientTransaction,request);
          } else {
	      // The ack is for the Dialog.
	      Dialog dialog=serverTransaction.getDialog();
	      ServerTransaction st  = (ServerTransaction) 
			dialog.getFirstTransaction();
	      if (ProxyDebug.debug) 
	          ProxyDebug.println("This ACK is for the Dialog, the first"+
                  " transaction (ServerTransaction) is:"+st);
              ClientTransaction  ct = 
			transactionsMapping.getClientTransaction (st);
	      if (ct == null) {
	         if (ProxyDebug.debug) 
	            ProxyDebug.println("Unable to find the mapping, we drop the request!" );
		 return;
	      }
		    
	       Dialog peerDialog = ct.getDialog();
	       if (peerDialog.getState().equals(DialogState.CONFIRMED))
                 peerDialog.sendAck(request);
	   }
   	} catch (Exception ex) {
	    ex.printStackTrace();
  	}
     }
}

    
