
package examples.proxy;

import java.util.*;
import examples.proxy.registrar.*;
import javax.sip.*;
import javax.sip.message.*; 
import javax.sip.header.*;
import javax.sip.address.*;
/**
*
*@version  JAIN-SIP-1.1
*
*@author Olivier Deruelle <deruelle@nist.gov>  <br/>
*
*<a href="{@docRoot}/uncopyright.html">This code is in the public domain.</a>
*
*/
public class OptionsProcessing   extends DefaultProcessing {

   /** Policy: we forward the OPTIONS following the TT
    */
    public void processRequest(Proxy proxy,Request request,
	ServerTransaction serverTransaction){
        try {
            
            ProxyDebug.println("Processing OPTIONS in progress.");    
            Registrar registrar=proxy.getRegistrar();
            ProxyUtilities proxyUtilities=proxy.getProxyUtilities();
            SipProvider sipProvider=proxy.getSipProvider();
            MessageFactory messageFactory=proxy.getMessageFactory();
            
            TransactionsMapping transactionsMapping=
				proxy.getTransactionsMapping();
            // If the Options is for the proxy, we have to send back the OK.
            // Otherwise we just forward!!!
            if (proxyUtilities.matchProxyAddress(request ) ) {
		if (ProxyDebug.debug)
                ProxyDebug.println("The OPTIONS is targeted for the proxy, 200 OK sent:\n");
                Response response=messageFactory.
			createResponse(Response.OK,request);
                sipProvider.sendResponse(serverTransaction,response);
                if (ProxyDebug.debug)
                    ProxyDebug.println(response.toString());
            }
            else {
		super.processRequest(proxy,request,serverTransaction);
             }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
}
