/*
 * RegisterProcessing.java
 *
 * Created on July 29, 2002, 11:10 AM
 */

package examples.proxy;
import java.util.*;
import examples.proxy.*;
import examples.proxy.registrar.*;
import javax.sip.*;
import javax.sip.message.*; 
import javax.sip.header.*;
import javax.sip.address.*;
/** Code to handle the processing of register messages.
*
*@version  JAIN-SIP-1.1
*
* @author  Olivier Deruelle <deruelle@nist.gov>  <br/>
*
*<a href="{@docRoot}/uncopyright.html">This code is in the public domain.</a>
*
*/
public class RegisterProcessing  extends DefaultProcessing {

  
    /**
     * 2 steps for processing a REGISTER request:
     *   - All the bindings and expiration times are managed by the registrar
     *   - A response (200 OK) is sent with any modified or additionals headers.
     * @param Request register to process
     * @param long server transaction id corresponding to the request to set
     */
    public void processRequest
	(Proxy proxy,Request request,ServerTransaction serverTransaction) {
        try {
            Registrar registrar=proxy.getRegistrar();
            registrar.processRegister(request,serverTransaction);
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
}
