/*
 * SubscribeProcessing.java
 *
 * Created on July 29, 2002, 11:09 AM
 */

package examples.proxy;

import java.util.*;
import javax.sip.*;
import javax.sip.message.*;
import javax.sip.header.*;
import javax.sip.address.*;
import examples.proxy.presenceserver.*;
import examples.proxy.registrar.*;
/**
 *
 * @author  deruelle
 * @version 1.0
 */
public class SubscribeProcessing extends DefaultProcessing {
    

/*****************************************************************/
/************* Reserved for the presence server ********************/
/*******************************************************************/
    
    
    public void processResponse(Proxy proxy,Response response,ClientTransaction clientTransaction) {
        
         if (!proxy.isPresenceServer()) {
            super.processResponse(proxy,response,clientTransaction);
            return;
        }
        
        // The presence server does forward SUBSCRIBE, so we expect an OK
        // for it! But we don't forward it...
        ProxyDebug.println("Processing OK related to SUBSCRIBE!!!!!!");
        
        // We have to keep trace of the Server and Client dialog, to retrieve
        // and change the tags in the message!
        /*
        if ( clientTransactionId!=null ) {
            // We get the client dialog:
            FromHeader fromHeader=response.getFromHeader();
            String fromTag=fromHeader.getTag();
            Dialog clientDialog=null;
            clientDialog=dialogManager.getDialog(clientTransactionId,false);
           
            // WE have to store the client dialog
            presenceServer.addClientDialog(fromTag,clientDialog);
        }
        else DebugProxy.println("DEBUG: SubscribeProcessing, process(), the server transaction Id is null ");
        */
    }
    
   
    
    /** Policy: we just
     * use our presence server
     */
    public void processRequest(Proxy proxy,Request request,ServerTransaction serverTransaction) {
        
        if (!proxy.isPresenceServer()) {
            ProxyDebug.println("Processing SUBSCRIBE in progress (Presence Server "+
            "disabled: default processing)");
            super.processRequest(proxy,request,serverTransaction);
            return;
        }
        
        ProxyDebug.println("Processing SUBSCRIBE in progress (Presence Server enabled)");
        PresenceServer presenceServer=proxy.getPresenceServer();
        ProxyUtilities proxyUtilities=proxy.getProxyUtilities();
        MessageFactory messageFactory=proxy.getMessageFactory();
        Registrar registrar=proxy.getRegistrar();
        HeaderFactory headerFactory=proxy.getHeaderFactory();
        SipProvider sipProvider=proxy.getSipProvider();
        
        try {
            Request requestCloned=(Request)request.clone();
            
            /************************ OK for the SUBSCRIBE *****************/
            
            // We have to check what kind of 2xx response to send back!!!
            Response response=messageFactory.createResponse(Response.OK,request);
            ToHeader toHeader=(ToHeader)response.getHeader(ToHeader.NAME);
            toHeader.setTag(proxyUtilities.generateTag());
            
            // WE have to add an Expires Header if not present
            ExpiresHeader expiresHeader=(ExpiresHeader)response.getHeader(
            ExpiresHeader.NAME);
           
            if (expiresHeader==null) {
                ProxyDebug.println("DEBUG, SubscribeProcessing, processRequest(), "+
                "There is no"+
                " ExpiresHeader, we have to create one");
                expiresHeader=headerFactory.createExpiresHeader(presenceServer.
                getExpiresTime());
                response.setHeader(expiresHeader);
            }
            else response.setHeader(expiresHeader);
            
          
            sipProvider.sendResponse(serverTransaction,response);
            ProxyDebug.print("200 OK sent:\n"+response.toString());
            
            /*********************** SUBSCRIBE **** ************************/
            /***************************************************************/
            
           presenceServer.sendSubscribe(proxy,request,serverTransaction);
           
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    
   

}
