/*
 * BuddyList.java
 *
 * Created on September 25, 2002, 2:46 PM
 */

package examples.proxy.gui;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import examples.proxy.registrar.*;
import examples.proxy.*;
/**
 *
 * @author  deruelle
 * @version 1.0
 */
public class RegistrationsList extends JList {
    
    
     protected DefaultListModel list;
     protected ProxyLauncher proxyLauncher;
   
    /** Creates new BuddyList */
    public RegistrationsList(ProxyLauncher proxyLauncher) {
        this.proxyLauncher=proxyLauncher;
        list=new DefaultListModel();
        this.setModel(list);
       
        list.addElement("(empty)");
             
    }

    public void uploadRegistrations(Registrar registrar) {
        try{
            RegistrationsTable registrationsTable=registrar.getRegistrationsTable();
            if (registrationsTable !=null) {
                Hashtable r=registrationsTable.getRegistrations();
                if (r==null || r.size()==0) {
                    list.addElement("(empty)");
                    return;
                }
                Enumeration e=r.keys();
                while (e.hasMoreElements()) {
                    String key=(String)e.nextElement();
                    list.addElement(key);
                }
            }
            else list.addElement("(empty)");
        }
        catch(Exception e) {}
    }
    
    
    public  void updateRegistration(Registration registration,boolean toRemove) {
   
        if (registration!=null ) {
            String key=registration.getKey();
            boolean b=list.contains(key);
            if (b) {
                if (toRemove) {
                    list.removeElement(key);
                    if (list.isEmpty()) list.addElement("(empty)");
                }
            }
            else {
                if (!toRemove) {
                    if (list.size()==1) {
                        String s=(String)list.firstElement();
                        if (s.equals("(empty)") ) list.removeElement(s);
                    }
                    list.addElement(key);
                }
            }
        }
    }
    
    public void clean() {
        list.removeAllElements();
        list.addElement("(empty)");
    }
    
}
