/*
 * SubscriberController.java
 *
 * Created on September 26, 2002, 6:00 PM
 */

package examples.proxy.presenceserver;

import java.util.*;
import javax.sip.*;
import javax.sip.message.*;
import javax.sip.header.*;
import javax.sip.address.*;
import examples.proxy.*;
/**
 *
 * @author  deruelle
 * @version 1.0
 */
public class PresentityManager {

    private Hashtable presentityList;
   
    /** Creates new SubscriberController */
    public PresentityManager() {
         presentityList=new Hashtable();
    }
    
    public boolean hasSubscriber(String present,String fromURL) {
        Presentity presentity=(Presentity)presentityList.get(present);
        if (presentity==null) return false;
        else {
           return presentity.hasSubscriber(fromURL);
        }
    }
    
    public boolean hasSubscriberWaiting(String present) {
        Presentity presentity=(Presentity)presentityList.get(present);
        if (presentity==null) return false;
        else {
           return presentity.hasSubscriberWaiting();
        }
    }
    
    public Vector getSubscriberList(String present) {
        Presentity presentity=(Presentity)presentityList.get(present);
        if (presentity==null) return null;
        else {
           return presentity.getSubscriberList();
        }
    }

    public void addSubscriber(String present,Subscriber subscriber) {
        Presentity presentity=(Presentity)presentityList.get(present);
       
        if (presentity==null) {
           ProxyDebug.println("DEBUG, PresentityManager, addSubscriber(), "+
            "We create a new presentity: "+present+" and add the subscriber: "+
            subscriber.getSubscriberURL() );
           presentity= new Presentity(present);
           presentity.addSubscriber(subscriber);
           presentityList.put(present,presentity);
           printPresentityList();
        }
        else {
            ProxyDebug.println("DEBUG, PresentityManager, addSubscriber(), "+
            "We add or update the subscriber: "+subscriber.getSubscriberURL() +" to "+
            "the presentity: "+present);
            presentity.addSubscriber(subscriber);
            printPresentityList();
        }
    }
    
    public void removeSubscriber(String present,String fromURL) {
        Presentity presentity=(Presentity)presentityList.get(present);
        if (presentity!=null) {
            ProxyDebug.println("DEBUG: PresentityManager, removeSubscriber(), "+
        " the subscriber: "+fromURL+" has been removed for the presentity: "+
             present);
            presentity.removeSubscriber(fromURL);
            // If the presentity does not have any subscribers, we remove it
            // also:
            if ( !presentity.hasSubscriber() ) {
                  ProxyDebug.println("DEBUG: PresentityManager, removeSubscriber(), "+
        " the presentity "+present+" has been removed (No subscribers!!) ");
                presentityList.remove(present);
            }
        }
        else ProxyDebug.println("DEBUG: PresentityManager, removeSubscriber(), "+
        " the presentity: "+present+" was not found... The subscriber: "+fromURL+" is not removed! ");
        printPresentityList();
    }
    
    public void removeAllSubscriptions(String fromURL) {
        Collection collection=presentityList.values();
        Vector presentities=new Vector(collection);
        Vector presentitiesBis=new Vector();
        for (int i=0;i<presentities.size();i++) {
            Presentity presentity=(Presentity)presentities.elementAt(i);
            if (presentity.hasSubscriber(fromURL) ) {
                   ProxyDebug.println("DEBUG: PresentityManager, removeAllSubscriptions(), "+
                   " the subscriber: "+fromURL+" has been removed for the presentity: "+
                   presentity.getPresentityURL());
                    presentity.removeSubscriber(fromURL);
            }
            if ( !presentity.hasSubscriber() ) {
                  ProxyDebug.println("DEBUG: PresentityManager, removeSubscriber(), "+
        " the presentity "+presentity.getPresentityURL()+" has been removed (No subscribers!!) ");
                presentityList.remove(presentity.getPresentityURL());
            }
        }
        printPresentityList();
    }
    
    public void printPresentityList() {
        Collection collection=presentityList.values();
        Vector presentities=new Vector(collection);
        ProxyDebug.println();
        ProxyDebug.println("************* DEBUG PresentityManager ************************************");
        ProxyDebug.println("************* Presentities record:    ************************************");
        ProxyDebug.println();
        for (int i=0;i<presentities.size();i++) {
            Presentity presentity=(Presentity)presentities.elementAt(i);
            ProxyDebug.println("presentity: "+presentity.getPresentityURL());
            Vector subscribers=presentity.getSubscriberList();
            for (int j=0;j<subscribers.size();j++) {
                Subscriber subscriber=(Subscriber)subscribers.elementAt(j);
                ProxyDebug.println("    subscriber: "+subscriber.getSubscriberURL()+
                "   delay:"+subscriber.isSubscribeDelayed());
            }
            ProxyDebug.println();
        }
        ProxyDebug.println("**************************************************************************");
        ProxyDebug.println();
    }
    
}
