/*******************************************************************************
* Product of NIST/ITL Advanced Networking Technologies Division (ANTD)         *
*******************************************************************************/
package gov.nist.javax.sip.parser;
import gov.nist.javax.sip.message.*;
import java.util.*;
/**
* Interface  that provides methods for processing good 
* and bad messages for the PipelinedMessageParser.
* @see PipelinedMsgParser
*/

public interface SIPMessageListener  extends ParseExceptionListener
{
	/**
	* This is called from the parser on successful message processing.
	* @see ParseExceptionListener for the method that gets called 
	*	on parse exception.
	* @param msg  SIP Message structure that is generated by the parser.
	*/
	public void processMessage(SIPMessage msg);
}
