package tools.tracesviewer;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/** 
*
*@version  JAIN-SIP-1.1
*
*@author Olivier Deruelle <deruelle@nist.gov>  <br/>
*
*<a href="{@docRoot}/uncopyright.html">This code is in the public domain.</a>
*
*/
public class ListenerTracesViewer  {

    public TracesViewer tracesViewer;
    public TracesSessionsDisplayer tracesSessionsDisplayer;
    
    public boolean ANIMATION_STARTED;
    public AboutFrame  aboutFrame;
    public HelpBox helpBox;
    public ScriptFrame scriptFrame; 
    
    /** Creates new ListenerTraceViewer */
    public ListenerTracesViewer(TracesViewer tracesViewer) {
        this.tracesViewer=tracesViewer;
        ANIMATION_STARTED=false;
        aboutFrame=new AboutFrame();
        tracesSessionsDisplayer=new TracesSessionsDisplayer();
        helpBox=new HelpBox();
        scriptFrame=new ScriptFrame();
    }

    
    public void displayAllSessionsMouseEvent(MouseEvent evt) {
        tracesSessionsDisplayer.show(tracesViewer.getTracesSessions());
    }
    
    public void helpMenuMouseEvent(MouseEvent evt){
        helpBox.show();
    }
    
    
    public void aboutMenuMouseEvent(MouseEvent evt){
       aboutFrame.animationThread.start();
        aboutFrame.show();
    }
    
    public void animationActionPerformed(ActionEvent evt) {
        if (tracesViewer.tracesCanvas.arrows.size()==0){
             new AlertFrame("Please hit Refresh, first!",JOptionPane.ERROR_MESSAGE);
        }
        else
            if (ANIMATION_STARTED) {
           
                tracesViewer.animationMenuItem.setBackground(Color.lightGray);
                tracesViewer.animationThread.stop();
                ANIMATION_STARTED=false;
            }
            else {
                 
             
                tracesViewer.animationThread.start();
          
                tracesViewer.animationMenuItem.setBackground(Color.green);
                ANIMATION_STARTED=true;
            }
    }
    
 
    
     /*
    public void refreshActionPerformed(ActionEvent evt){   
        if (ANIMATION_STARTED)
            new AlertFrame("You must stop the animation before refreshing the traces!",JOptionPane.ERROR_MESSAGE);
        else {
            TracesSessions tracesSessions=tracesViewerLauncher.refreshTracesSessions();
            tracesViewerLauncher.tracesSessionsList.setTracesSessions(tracesSessions);
            tracesViewerLauncher.tracesSessionsList.updateTracesCanvas();
            tracesViewerLauncher.initComboBox();
            if (tracesSessionsDisplayer.isVisible())
                tracesSessionsDisplayer.show(tracesSessions);
        }
        
    }
      */
    
     public void refreshActionPerformed(MouseEvent evt){   
        if (ANIMATION_STARTED)
            new AlertFrame("You must stop the animation before refreshing the traces!",JOptionPane.ERROR_MESSAGE);
        else {
            TracesSessions tracesSessions=tracesViewer.refreshTracesSessions();
            tracesViewer.tracesSessionsList.setTracesSessions(tracesSessions);
            tracesViewer.tracesSessionsList.updateTracesCanvas();
            tracesViewer.initComboBox();
            if (tracesSessionsDisplayer.isVisible())
                tracesSessionsDisplayer.show(tracesSessions);
        }
        
    }
    
    
    public void scriptActionPerformed(ActionEvent evt){
        String s = tracesViewer.choice.getSelectedItem() ;
        String text= tracesViewer.getAuxInfo(s) ;
        scriptFrame=new ScriptFrame();
        scriptFrame.setText(s,text);
        scriptFrame.show();
    }
    
    public void tracesSessionsListStateChanged(ItemEvent e){
       if (ANIMATION_STARTED) {
           tracesViewer.animationMenuItem.setBackground(Color.lightGray);
           tracesViewer.animationThread.stop();
           ANIMATION_STARTED=false;
       }    
       tracesViewer.tracesSessionsList.updateTracesCanvas(e);
    }
    
}
