package tools.tracesviewer;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.*;
import org.xml.sax.*;
import java.io.* ;


public class TracesFileParser{

	InputSource xmlSource = null ;

	
	public TracesFileParser(String strSource){
		 byte[] bytes = strSource.getBytes();
                InputStream input = new ByteArrayInputStream(bytes);
		xmlSource = new InputSource(input) ;
	}

	public TracesFileParser(InputStream streamSource){
	    xmlSource = new InputSource(streamSource) ;
	}
	
        public void setXMLsource(String strSource){
	    byte[] bytes = strSource.getBytes();
	    InputStream input = new ByteArrayInputStream(bytes);
	    xmlSource = new InputSource(input) ;
	}

        public void setXMLsource(InputStream streamSource){
	    xmlSource = new InputSource(streamSource) ;
	}

	public TracesSession parse() throws SAXException , IOException{
		
		TracesSession tracesSession = new TracesSession() ;			

		DOMParser parser = new DOMParser();
		parser.parse(xmlSource);
		
		Node messagesNode = parser.getDocument().getFirstChild() ;

	        // Get the log description attribute.
                String logDescription =null;
                if (messagesNode.getAttributes().getNamedItem("logDescription")!=null) {
		    logDescription  = 
			messagesNode.getAttributes().getNamedItem("logDescription").getNodeValue();
                }
                System.out.println("logDescription:"+logDescription);
		// Set the log description in the traces session.
		tracesSession.setLogDescription(logDescription);

		NodeList nodeList = messagesNode.getChildNodes() ;

		TracesMessage tracesMessage = null ;

		for(int i = 0 ; i < nodeList.getLength() ; i++){
			
			tracesMessage = new TracesMessage() ;
				
			// We have a message
			if(nodeList.item(i).getNodeName().equals("message")){
					
			// Get the attributes
			NamedNodeMap messageNodeMap = nodeList.item(i).getAttributes() ;
			
			// mandatory fields
			if(messageNodeMap.getNamedItem("from") != null &&
				messageNodeMap.getNamedItem("to") != null &&
				messageNodeMap.getNamedItem("time") != null &&
				messageNodeMap.getNamedItem("firstLine") != null &&
				messageNodeMap.getNamedItem("transactionId") != null){

				tracesMessage.setFrom(messageNodeMap.getNamedItem("from").getNodeValue()) ;
						
				tracesMessage.setTo(messageNodeMap.getNamedItem("to").getNodeValue()) ;

				tracesMessage.setTime(messageNodeMap.getNamedItem("time").getNodeValue()) ;

				tracesMessage.setFirstLine(messageNodeMap.getNamedItem("firstLine").getNodeValue()) ;
				
				tracesMessage.setTransactionId(messageNodeMap.getNamedItem("transactionId").getNodeValue()) ;
			
			}else{
				System.out.println("Problem ...") ;
				System.out.println("these tags are mandatory for a message in the xml log trace :") ;
				System.out.println("from, to, time, firstLine, transactionId") ;
				return null ;
			}

			// maybe a status Message
			if (messageNodeMap.getNamedItem("statusMessage") != null) 
				 tracesMessage.setStatusInfo(messageNodeMap.getNamedItem("statusMessage").getNodeValue()) ;
				
			//Get the Text of the message
			NodeList messageNodeList = nodeList.item(i).getChildNodes() ;
					
			if(messageNodeList.getLength() > 0){
				for(int j = 0 ; j < messageNodeList.getLength() ; j++)
					if(messageNodeList.item(j).getNodeType() == Node.CDATA_SECTION_NODE){
						tracesMessage.setMessageString(messageNodeList.item(j).getNodeValue()) ;
					}
						
					}else{
						System.out.println("xml File problem\n") ;
						return null ;
					}
		
				tracesSession.add(tracesMessage) ;

			}
		}
		
		return tracesSession ;
	} // end parse


} // end class
